<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\DBAL\Connection;

class ZeramentoSaldoService {

    protected $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
	
	public function adqSaldoNeg($NRORG, $CDCLIENTE, $CDTIPOCONS, $DTMOVEXTCONS){
		$params = array( 
		    ':TCDTIPOCONS'  => $DTMOVEXTCONS ? ' ' : 'T',
			':DTMOVEXTCONS' => $DTMOVEXTCONS,
			':CDTIPOCONS'   => $CDTIPOCONS,	
			':CDCLIENTE'	=> $CDCLIENTE,
			':NRORG'        => $NRORG
		);
		return $this->connection->fetchAll(self::ADQ_SALDO_NEG, $params);
	}
	
	public function adqSeqMovExtr($NRORG, $CDCONSUMIDOR, $CDCLIENTE, $CDFAMILISALD, $DTMOVEXTCONS){
		$params = array( 
			':DTMOVEXTCONS'   => $DTMOVEXTCONS,
			':CDFAMILISALD'   => $CDFAMILISALD,	
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':CDCLIENTE'	  => $CDCLIENTE,
			':NRORG'          => $NRORG
		);
		return $this->connection->fetchAssoc(self::ADQ_SEQ_MOV_EXTR, $params);
	}
	
	public function acmInsMovExtrato($NRORG, $CDCONSUMIDOR, $CDCLIENTE, $CDFAMILISALD, $DTMOVEXTCONS, $NRSEQMOVEXT, $VRSALDCONEXT, $NRSEQREGCREDVND ){
		$paramsNRORG = array( ':NRORG' => $NRORG	);
		$CDTIPORECE = $this->connection->fetchAssoc(self::TIPO_RECE, $paramsNRORG);
		
		$params = array( 
			':CDTIPORECE'		  => $CDTIPORECE['CDTIPORECE'],
			':DSOPEEXTCONS'   => 'Zeramento do Saldo',
            ':IDTPMOVEXT'     => 'C',
			':NRSEQREGCREDVND'=> str_pad(($NRSEQREGCREDVND + 1), 20, '0', STR_PAD_LEFT),
			':DTMOVEXTCONS'   => $DTMOVEXTCONS,
			':CDFAMILISALD'   => $CDFAMILISALD,	
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':VRSALDCONEXT'   => 0,
			':VRMOVEXTCONS'   => $VRSALDCONEXT,
			':NRSEQMOVEXT'    => $NRSEQMOVEXT,
			':CDCLIENTE'	  => $CDCLIENTE,
			':NRORG'          => $NRORG
		);
		return $this->connection->executeQuery(self::ADQ_INS_MOV_EXTRATO, $params);
		
		
	}
	
	const ADQ_SALDO_NEG = "
		SELECT
		   COUNT(*) AS NRREGISTROS,
		   E.CDCLIENTE,
		   E.CDCONSUMIDOR,
		   E.CDFAMILISALD,
		   DT.DTMOVEXTCONS,
		   TO_DATE(TO_CHAR(DT.DTMOVEXTCONS, 'DD/MM/YYYY') || ' 23:59:00', 'DD/MM/YYYY HH24:MI:SS') AS DTMOV,
		   ROUND(E.VRSALDCONEXT * -1,2) AS VRSALDCONEXT
		FROM
		   CONSUMIDOR C,
		   EXTRATOCONS E,
		   (SELECT
		       E.CDCLIENTE,
		       E.CDCONSUMIDOR,
		       E.CDFAMILISALD,       
		       D.DTMOVEXTCONS,
		       MAX(E.NRSEQMOVEXT) AS NRSEQMOVEXT,
		       D.NRORG
		    FROM
		       EXTRATOCONS E,
		       (SELECT
		           CDCLIENTE,
		           CDCONSUMIDOR,
		           CDFAMILISALD,
		           NRORG,
		           MAX(DTMOVEXTCONS) AS DTMOVEXTCONS
		        FROM
		           EXTRATOCONS
		        WHERE
		           (CDCLIENTE = :CDCLIENTE) AND
		           (TO_DATE(TO_CHAR(DTMOVEXTCONS, 'DD/MM/YYYY'), 'DD/MM/YYYY') <= TO_DATE(:DTMOVEXTCONS, 'DD/MM/YYYY')) AND
		           (NRORG = :NRORG)
		        GROUP BY
		           CDCLIENTE,
		           CDCONSUMIDOR,
		           CDFAMILISALD,
		           NRORG            
		       ) D
		    WHERE
		       (E.CDCLIENTE    = D.CDCLIENTE)    AND
		       (E.CDCONSUMIDOR = D.CDCONSUMIDOR) AND
		       (E.CDFAMILISALD = D.CDFAMILISALD) AND
		       (E.DTMOVEXTCONS = D.DTMOVEXTCONS) AND
		       (E.NRORG = D.NRORG)
		    GROUP BY
		       E.CDCLIENTE,
		       E.CDCONSUMIDOR,
		       E.CDFAMILISALD,
		       D.DTMOVEXTCONS,
		       D.NRORG
		   ) DT
		WHERE
		   (C.CDCLIENTE    = :CDCLIENTE)    AND
		   (C.CDTIPOCONS   = :CDTIPOCONS)   AND
		   (C.NRORG        = :NRORG)          AND
		   (C.CDCLIENTE    = E.CDCLIENTE)     AND
		   (C.CDCONSUMIDOR = E.CDCONSUMIDOR)  AND
		   (E.CDCLIENTE    = DT.CDCLIENTE)    AND
		   (E.CDCONSUMIDOR = DT.CDCONSUMIDOR) AND
		   (E.CDFAMILISALD = DT.CDFAMILISALD) AND
		   (E.DTMOVEXTCONS = DT.DTMOVEXTCONS) AND
		   (E.NRSEQMOVEXT  = DT.NRSEQMOVEXT)  AND
		   (E.VRSALDCONEXT < 0) AND
		   (E.NRORG = DT.NRORG) 
		   
		GROUP BY
		   E.CDCLIENTE,
		   E.CDCONSUMIDOR,
		   E.CDFAMILISALD,
		   DT.DTMOVEXTCONS,
		   E.VRSALDCONEXT
	";
	
	const ADQ_SALDO_CONS = "
		SELECT
	       S.CDCLIENTE, 
	       S.CDCONSUMIDOR ,
	       S.CDFAMILISALD,
	       F.NMFAMILISALD,
	       S.VRSALDCONFAM
	    FROM SALDOCONS S, FAMILIASALDO F
	    WHERE
	       (S.CDCLIENTE     = :CDCLIENTE   ) AND
	       (S.CDCONSUMIDOR  = :CDCONSUMIDOR) AND
	       (S.NRORG         = :NRORG         ) AND
	       ((S.CDFAMILISALD = :CDFAMILISALD) OR (:TCDFAMILISALD = 'T')) AND
	       (S.CDFAMILISALD  = F.CDFAMILISALD ) AND
	       (S.NRORG         = F.NRORG        ) 
	    ORDER BY  
	     S.CDFAMILISALD";
	     
	 const ADQ_SEQ_MOV_EXTR = "
	 SELECT
	   LPAD((NVL(MAX(NRSEQMOVEXT),0) + 1), 3, '0') as NRSEQMOVEXT
	FROM
	   EXTRATOCONS
	WHERE
	   (CDCLIENTE    = :CDCLIENTE)    AND
	   (NRORG		 = :NRORG)  	  AND
	   (CDCONSUMIDOR = :CDCONSUMIDOR) AND
	   (CDFAMILISALD = :CDFAMILISALD) AND
	   (DTMOVEXTCONS = :DTMOVEXTCONS)";
	   
	const TIPO_RECE = " 
	   SELECT
		   A.CDTIPORECE
		FROM
		   (SELECT
		      MIN(CDTIPORECE) AS CDTIPORECE
		   FROM
		      TIPORECE
		   WHERE
		      IDTIPORECE = '4' AND
		      NRORG 	 = :NRORG) A";

	
	const ADQ_INS_MOV_EXTRATO = "
	INSERT INTO EXTRATOCONS
	   (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, CDTIPORECE,
	    DSOPEEXTCONS, VRMOVEXTCONS, VRSALDCONEXT, IDTPMOVEXT, DTULTATUEXT, NRSEQREGCREDVND,
	    IDIMPEXTRATO)
	VALUES
	   (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :DTMOVEXTCONS, :NRSEQMOVEXT, :CDTIPORECE,
	    :DSOPEEXTCONS, :VRMOVEXTCONS, :VRSALDCONEXT, :IDTPMOVEXT, SYSDATE, :NRSEQREGCREDVND,
	    'S')
    ";
}